Skip to main content
POST
/
datasets
/
{dataset_id}
/
retrieve
Retrieve Chunks from a Knowledge Base / Test Retrieval
curl --request POST \
  --url https://{api_base_url}/datasets/{dataset_id}/retrieve \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "query": "<string>",
  "attachment_ids": [
    "<string>"
  ]
}
'
import requests

url = "https://{api_base_url}/datasets/{dataset_id}/retrieve"

payload = {
"query": "<string>",
"attachment_ids": ["<string>"]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({query: '<string>', attachment_ids: ['<string>']})
};

fetch('https://{api_base_url}/datasets/{dataset_id}/retrieve', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));


{
  "query": {
    "content": "What is Dify?"
  },
  "records": [
    {
      "segment": {
        "id": "f3d1c7be-9f3a-40d8-8eb8-3a1ef9c3f2c1",
        "position": 1,
        "document_id": "a8e0e5b5-78c6-4130-a5ce-25feb0e0b4ac",
        "content": "Dify is an open-source LLM app development platform.",
        "sign_content": "",
        "answer": "",
        "word_count": 9,
        "tokens": 12,
        "keywords": [
          "dify",
          "platform",
          "llm"
        ],
        "index_node_id": "a1b2c3d4-e5f6-7890-abcd-000000000001",
        "index_node_hash": "abc123def456",
        "hit_count": 1,
        "enabled": true,
        "disabled_at": null,
        "disabled_by": null,
        "status": "completed",
        "created_by": "ad313dd6-ef04-4dd1-a5b0-c0f0b9e2e7e4",
        "created_at": 1741267200,
        "indexing_at": 1741267200,
        "completed_at": 1741267200,
        "error": null,
        "stopped_at": null,
        "document": {
          "id": "a8e0e5b5-78c6-4130-a5ce-25feb0e0b4ac",
          "data_source_type": "upload_file",
          "name": "guide.txt",
          "doc_type": null,
          "doc_metadata": null
        }
      },
      "child_chunks": [],
      "score": 0.92,
      "tsne_position": null,
      "files": [],
      "summary": null
    }
  ]
}

Authorizations

Authorization
string
header
required

API Key authentication. For all API requests, include your API Key in the Authorization HTTP Header, prefixed with Bearer. Example: Authorization: Bearer {API_KEY}. Strongly recommend storing your API Key on the server-side, not shared or stored on the client-side, to avoid possible API-Key leakage that can lead to serious consequences. Requests with a missing or invalid API key fail with HTTP 401 and error code unauthorized.

Path Parameters

dataset_id
string<uuid>
required

Knowledge base ID.

Body

application/json
query
string
required

Search query text.

Maximum string length: 250
retrieval_model
object

Retrieval model configuration. Controls how chunks are searched and ranked when querying this knowledge base.

attachment_ids
string[] | null

List of attachment IDs to include in the retrieval context.

Response

Retrieval results.

query
object

The original query object.

records
object[]

List of matched retrieval records.

Last modified on July 9, 2026